package main

import (
	"encoding/gob"
	"os"
	"time"

	"github.com/beego/beego/v2/client/cache"
	"github.com/beego/beego/v2/core/logs"
)

type City struct {
	Name string
}

func main() {
	//cache, _ := cache.NewCache("memory", `{"interval": 60}`)
	cache, err := cache.NewCache("file", `{"CachePath": "cache", "FileSuffix": ".cache", "EmbedExpiry": "60", "DirectoryLevel": "5"}`)
	if err != nil {
		logs.Error(err)
		os.Exit(-1)
	}
	logs.Info(cache.Get(nil, "name"))
	timeout := 5 * time.Second
	cache.Put(nil, "name", "xianbin", timeout)
	logs.Info(cache.Get(nil, "name"))
	time.Sleep(6 * time.Second)
	logs.Info(cache.Get(nil, "name"))

	cache.Delete(nil, "name")
	logs.Info(cache.IsExist(nil, "name"))

	gob.Register(new(City))
	c := &City{
		Name: "shanghai",
	}
	cache.Put(nil, "city", c, 5*time.Second)
	logs.Info(cache.Get(nil, "city"))
}
